import { StringMap } from "./Support";
export declare class ErrorMessage {
    static InternalError: string;
    static JSONParseError: string;
    static ReadError: string;
    static UnicodeHighSurrogateWithoutLowSurrogate: string;
    static ArrayIsInvalidJSONSchema: string;
    static NullIsInvalidJSONSchema: string;
    static RefMustBeString: string;
    static AdditionalTypesForbidRequired: string;
    static NoTypeSpecified: string;
    static FalseSchemaNotSupported: string;
    static RefWithFragmentNotAllowed: string;
    static InvalidJSONSchemaType: string;
    static RequiredMustBeStringOrStringArray: string;
    static RequiredElementMustBeString: string;
    static TypeMustBeStringOrStringArray: string;
    static TypeElementMustBeString: string;
    static ArrayItemsMustBeStringOrArray: string;
    static IDMustHaveAddress: string;
    static WrongAccessorEntryArrayLength: string;
    static SetOperationCasesIsNotArray: string;
    static CannotFetchSchema: string;
    static MoreThanOneUnionMemberName: string;
    static NoGraphQLQueriesDefined: string;
    static UnknownSourceLanguage: string;
    static UnknownOutputLanguage: string;
    static NeedExactlyOneSchema: string;
    static MoreThanOneSchemaGiven: string;
    static NoGraphQLQueryGiven: string;
    static NoGraphQLSchemaInDir: string;
    static MoreThanOneGraphQLSchemaInDir: string;
    static SourceLangMustBeGraphQL: string;
    static GraphQLSchemaNeeded: string;
    static InputFileDoesNotExist: string;
    static CannotMixJSONWithOtherSamples: string;
    static CannotMixNonJSONInputs: string;
    static UnknownDebugOption: string;
    static InvalidSchemaTopLevelRefs: string;
    static NoLanguageOrExtension: string;
    static CLIOptionParsingFailed: string;
    static NoForwardDeclarableTypeInCycle: string;
    static TypeAttributesNotPropagated: string;
    static NoEmptyUnions: string;
    static UnknownRendererOptionValue: string;
    static TypeScriptCompilerError: string;
}
export declare class QuickTypeError extends Error {
    readonly errorMessage: string;
    readonly messageName: string;
    readonly properties: StringMap;
    constructor(errorMessage: string, messageName: string, userMessage: string, properties: StringMap);
}
export declare function messageError(message: string): never;
export declare function messageError(message: string, properties: StringMap): never;
export declare function messageAssert(assertion: boolean, message: string): void;
export declare function messageAssert(assertion: boolean, message: string, properties: StringMap): void;
