"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ErrorMessage = /** @class */ (function () {
    function ErrorMessage() {
    }
    ErrorMessage.InternalError = "Internal error: ${message}";
    // Misc
    ErrorMessage.JSONParseError = "Syntax error in ${description} JSON ${address}: ${message}";
    ErrorMessage.ReadError = "Cannot read from file or URL ${fileOrURL}: ${message}";
    ErrorMessage.UnicodeHighSurrogateWithoutLowSurrogate = "Malformed unicode: High surrogate not followed by low surrogate";
    // JSON Schema input
    ErrorMessage.ArrayIsInvalidJSONSchema = "An array is not a valid JSON Schema";
    ErrorMessage.NullIsInvalidJSONSchema = "null is not a valid JSON Schema";
    ErrorMessage.RefMustBeString = "$ref must be a string";
    ErrorMessage.AdditionalTypesForbidRequired = "Can't have non-specified required properties but forbidden additionalTypes";
    ErrorMessage.NoTypeSpecified = "JSON Schema must specify at least one type";
    ErrorMessage.FalseSchemaNotSupported = 'Schema "false" is not supported';
    ErrorMessage.RefWithFragmentNotAllowed = "Ref URI with fragment is not allowed: ${ref}";
    ErrorMessage.InvalidJSONSchemaType = "Value of type ${type} is not valid JSON Schema";
    ErrorMessage.RequiredMustBeStringOrStringArray = "`required` must be string or array of strings, but is ${actual}";
    ErrorMessage.RequiredElementMustBeString = "`required` must contain only strings, but it has ${element}";
    ErrorMessage.TypeMustBeStringOrStringArray = "`type` must be string or array of strings, but is ${actual}";
    ErrorMessage.TypeElementMustBeString = "`type` must contain only strings, but it has ${element}";
    ErrorMessage.ArrayItemsMustBeStringOrArray = "Array items must be an array or an object, but is ${actual}";
    ErrorMessage.IDMustHaveAddress = "$id doesn't have an address: ${id}";
    ErrorMessage.WrongAccessorEntryArrayLength = "Accessor entry array must have the same number of entries as the ${operation}";
    ErrorMessage.SetOperationCasesIsNotArray = "${operation} cases must be an array, but is ${cases}";
    ErrorMessage.CannotFetchSchema = "Cannot fetch schema at address ${address}";
    ErrorMessage.MoreThanOneUnionMemberName = "More than one name given for union member: ${names}";
    // GraphQL input
    ErrorMessage.NoGraphQLQueriesDefined = "GraphQL file doesn't have any queries defined.";
    // Driver
    ErrorMessage.UnknownSourceLanguage = "Unknown source language ${lang}";
    ErrorMessage.UnknownOutputLanguage = "Unknown output language ${lang}";
    ErrorMessage.NeedExactlyOneSchema = "Must have exactly one schema for ${name}";
    ErrorMessage.MoreThanOneSchemaGiven = "More than one schema given for ${name}";
    ErrorMessage.NoGraphQLQueryGiven = "Please specify at least one GraphQL query as input";
    ErrorMessage.NoGraphQLSchemaInDir = "No GraphQL schema in ${dir}";
    ErrorMessage.MoreThanOneGraphQLSchemaInDir = "More than one GraphQL schema in ${dir}";
    ErrorMessage.SourceLangMustBeGraphQL = "If a GraphQL schema is specified, the source language must be GraphQL";
    ErrorMessage.GraphQLSchemaNeeded = "Please specify a GraphQL schema with --graphql-schema or --graphql-introspect";
    ErrorMessage.InputFileDoesNotExist = "Input file ${filename} does not exist";
    ErrorMessage.CannotMixJSONWithOtherSamples = "Cannot mix JSON samples with JSON Schems, GraphQL, or TypeScript in input subdirectory ${dir}";
    ErrorMessage.CannotMixNonJSONInputs = "Cannot mix JSON Schema, GraphQL, and TypeScript in an input subdirectory ${dir}";
    ErrorMessage.UnknownDebugOption = "Unknown debug option ${option}";
    ErrorMessage.InvalidSchemaTopLevelRefs = "Schema top level refs must be `/definitions/`, but is `${actual}`";
    ErrorMessage.NoLanguageOrExtension = "Please specify a language (--lang) or an output file extension";
    ErrorMessage.CLIOptionParsingFailed = "Option parsing failed: ${message}";
    // IR
    ErrorMessage.NoForwardDeclarableTypeInCycle = "Cannot resolve cycle because it doesn't contain types that can be forward declared";
    ErrorMessage.TypeAttributesNotPropagated = "Type attributes for ${count} types were not carried over to the new graph";
    ErrorMessage.NoEmptyUnions = "Trying to make an empty union - do you have an impossible type in your schema?";
    // Rendering
    ErrorMessage.UnknownRendererOptionValue = "Unknown value ${value} for option ${name}";
    // TypeScript input
    ErrorMessage.TypeScriptCompilerError = "TypeScript error: ${message}";
    return ErrorMessage;
}());
exports.ErrorMessage = ErrorMessage;
/*
type Error =
    | { message: ErrorMessage.InternalError; properties: { message: string } }

    // Misc
    | { message: ErrorMessage.JSONParseError; properties: { description: string; address: string; message: string } }
    | { message: ErrorMessage.ReadError; properties: { fileOrURL: string; message: string } }
    | { message: ErrorMessage.UnicodeHighSurrogateWithoutLowSurrogate}

    // JSON Schema input
    | { message: ErrorMessage.ArrayIsInvalidJSONSchema; properties: {} }
    | { message: ErrorMessage.NullIsInvalidJSONSchema; properties: {} }
    | { message: ErrorMessage.RefMustBeString; properties: {} }
    | { message: ErrorMessage.AdditionalTypesForbidRequired; properties: {} }
    | { message: ErrorMessage.NoTypeSpecified; properties: {} }
    | { message: ErrorMessage.FalseSchemaNotSupported; properties: {} }
    | { message: ErrorMessage.RefWithFragmentNotAllowed; properties: { ref: string } }
    | { message: ErrorMessage.InvalidJSONSchemaType; properties: { type: string } }
    | { message: ErrorMessage.RequiredMustBeStringOrStringArray; properties: { actual: any } }
    | { message: ErrorMessage.RequiredElementMustBeString; properties: { element: any } }
    | { message: ErrorMessage.TypeMustBeStringOrStringArray; properties: { actual: any } }
    | { message: ErrorMessage.TypeElementMustBeString; properties: { element: any } }
    | { message: ErrorMessage.ArrayItemsMustBeStringOrArray; properties: { actual: any } }
    | { message: ErrorMessage.IDMustHaveAddress, properties: { id: string } }
    | { message: ErrorMessage.WrongAccessorEntryArrayLength, properties: { operation: string } }
    | { message: ErrorMessage.SetOperationCasesIsNotArray; properties: { operation: string; cases: any } }
    | { message: ErrorMessage.CannotFetchSchema; properties: { address: string } }
    | { message: ErrorMessage.MoreThanOneUnionMemberName; properties: { names: string[] } }
    | { message: ErrorMessage.InvalidSchemaTopLevelRefs; properties: { actual: string[] } }

    // GraphQL input
    | { message: ErrorMessage.NoGraphQLQueriesDefined; properties: {} }

    // Driver
    | { message: ErrorMessage.UnknownSourceLanguage; properties: { lang: string } }
    | { message: ErrorMessage.UnknownOutputLanguage; properties: { lang: string } }
    | { message: ErrorMessage.NeedExactlyOneSchema; properties: { name: string } }
    | { message: ErrorMessage.MoreThanOneSchemaGiven; properties: { name: string } }
    | { message: ErrorMessage.NoGraphQLQueryGiven; properties: {} }
    | { message: ErrorMessage.NoGraphQLSchemaInDir; properties: { dir: string } }
    | { message: ErrorMessage.MoreThanOneGraphQLSchemaInDir; properties: { dir: string } }
    | { message: ErrorMessage.SourceLangMustBeGraphQL; properties: {} }
    | { message: ErrorMessage.GraphQLSchemaNeeded; properties: {} }
    | { message: ErrorMessage.InputFileDoesNotExist; properties: { filename: string } }
    | { message: ErrorMessage.CannotMixJSONWithOtherSamples; properties: { dir: string } }
    | { message: ErrorMessage.CannotMixNonJSONInputs; properties: { dir: string } }
    | { message: ErrorMessage.UnknownDebugOption; properties: { option: string } }
    | { message: ErrorMessage.NoLanguageOrExtension; properties: {} }
    | { message: ErrorMessage.CLIOptionParsingFailed; properties: { message: string } }

    // IR
    | { message: ErrorMessage.NoForwardDeclarableTypeInCycle; properties: {} }
    | { message: ErrorMessage.TypeAttributesNotPropagated; properties: { count: number } }
    | { message: ErrorMessage.NoEmptyUnions; properties: {} }

    // Rendering
    | { message: ErrorMessage. UnknownRendererOptionValue; properties: { value: string; name: string } }

    // TypeScript input
    | { message: ErrorMessage.TypeScriptCompilerError; properties: { message: string } }
    ;
*/
/*
type Errors =
   { kind: "foo"; properties: { quux: number } } |
   { kind: "bar"; properties: { frob: boolean } };
type Kind = Errors extends { kind: infer T } ? T : never;
type properties = Errors extends { properties: infer P } ? P : never;
type KindFor<P> = Extract<Errors, { properties: P }> extends { kind: infer K } ? K : never;

const messages: { [kind in Kind]: string } = {
    foo: "Foo error!",
    bar: "A bar is missing!"
};

function error<P extends Props>(kind: KindFor<P>, props: P): void {
    console.log(messages[kind as any], props);
}

error("foo", { quux: 123 });
*/
var QuickTypeError = /** @class */ (function (_super) {
    __extends(QuickTypeError, _super);
    function QuickTypeError(errorMessage, messageName, userMessage, properties) {
        var _this = _super.call(this, userMessage) || this;
        _this.errorMessage = errorMessage;
        _this.messageName = messageName;
        _this.properties = properties;
        return _this;
    }
    return QuickTypeError;
}(Error));
exports.QuickTypeError = QuickTypeError;
function messageError(message, properties) {
    var userMessage = message;
    if (properties !== undefined) {
        for (var _i = 0, _a = Object.getOwnPropertyNames(properties); _i < _a.length; _i++) {
            var name = _a[_i];
            var value = properties[name];
            if (typeof value !== "string") {
                value = JSON.stringify(value);
            }
            userMessage = userMessage.replace("${" + name + "}", value);
        }
    }
    else {
        properties = {};
    }
    var messageName;
    var errorMessages = ErrorMessage;
    for (var _b = 0, _c = Object.getOwnPropertyNames(ErrorMessage); _b < _c.length; _b++) {
        var name = _c[_b];
        if (errorMessages[name] === message) {
            messageName = name;
            break;
        }
    }
    if (messageName === undefined) {
        messageName = "UnknownError";
    }
    throw new QuickTypeError(message, messageName, userMessage, properties);
}
exports.messageError = messageError;
function messageAssert(assertion, message, properties) {
    if (assertion)
        return;
    return messageError(message, properties);
}
exports.messageAssert = messageAssert;
